Patch against 2.6.9